class RegexpScan::Scanner
  def initialize(filter_regexp)
    @filter_regexp = to_regexp(filter_regexp)
    validation!
  end

  def execute(string)
    string.scan(/#{@filter_regexp}/)
  end

  private

  def to_regexp(string_or_regexp)
    case string_or_regexp
    when String
      Regexp.new(string_or_regexp)
    when Regexp
      string_or_regexp
    else
      nil
    end
  end

  def validation!
    unless @filter_regexp.is_a?(Regexp)
      raise ArgumentError.new('Expect Argument is Regexp or String')
    end
  end
end